Option Strict On
Option Explicit On 

Imports Interop.QBFC5
Module BuildCustomerModRqModule

    Public Sub BuildCustomerModRq(ByVal cust As Customer, ByVal requestMsgSet As IMsgSetRequest, ByVal country As String)

        If (requestMsgSet Is Nothing) Then
            Exit Sub
        End If

        'Add the request to the message set request object. 
        Dim customerMod As ICustomerMod
        customerMod = requestMsgSet.AppendCustomerModRq()

        'Set the elements of ICustomerMod. 

        ' Set the value of the ICustomerMod.ListID element. 
        customerMod.ListID.SetValue(cust.listId)

        ' Set the value of the ICustomerMod.EditSequence element. 
        customerMod.EditSequence.SetValue(cust.editSequence)

        ' Set the value of the ICustomerMod.Name element. 
        customerMod.Name.SetValue(cust.getQBName)

        ' Set the value of the ICustomerMod.IsActive element. 
        customerMod.IsActive.SetValue(True)

        ' Set the value of the ICustomerMod.CompanyName element. 
        customerMod.CompanyName.SetValue(cust.companyName)

        ' Set the value of the ICustomerMod.FirstName element. 
        customerMod.FirstName.SetValue(cust.firstName)

        ' Set the value of the ICustomerMod.LastName element. 
        customerMod.LastName.SetValue(cust.lastName)

        ' Set the value of the IAddress.Modr1 element. 
        customerMod.BillAddress.Addr1.SetValue(cust.companyName)
        customerMod.BillAddress.Addr2.SetValue(cust.firstName & " " & cust.lastName)
        customerMod.BillAddress.Addr3.SetValue(cust.streetAddress)

        ' Set the value of the IModress.City element. 
        customerMod.BillAddress.City.SetValue(cust.city)

        If (country = "US") Then
            ' Set the value of the IModress.State element. 
            customerMod.BillAddress.State.SetValue(cust.state)

        End If
        If (country = "UK") Then
            ' Set the value of the IModress.County element. 
            customerMod.BillAddress.County.SetValue(cust.state)

        End If
        If (country = "CA") Then
            ' Set the value of the IModress.Province element. 
            customerMod.BillAddress.Province.SetValue(cust.state)

        End If
        ' Set the value of the IModress.PostalCode element. 
        customerMod.BillAddress.PostalCode.SetValue(cust.postcode)

        ' Set the value of the IModress.Country element. 
        customerMod.BillAddress.Country.SetValue(cust.country)

        ' Set the value of the IModress.Modr1 element. 
        customerMod.ShipAddress.Addr1.SetValue(cust.companyName)
        customerMod.ShipAddress.Addr2.SetValue(cust.firstName & " " & cust.lastName)
        customerMod.ShipAddress.Addr3.SetValue(cust.streetAddress)

        ' Set the value of the IModress.City element. 
        customerMod.ShipAddress.City.SetValue(cust.city)

        If (country = "US") Then
            ' Set the value of the IModress.State element. 
            customerMod.ShipAddress.State.SetValue(cust.state)

        End If
        If (country = "UK") Then
            ' Set the value of the IModress.County element. 
            customerMod.ShipAddress.County.SetValue(cust.state)

        End If
        If (country = "CA") Then
            ' Set the value of the IAddress.Province element. 
            customerMod.ShipAddress.Province.SetValue(cust.state)

        End If
        ' Set the value of the IAddress.PostalCode element. 
        customerMod.ShipAddress.PostalCode.SetValue(cust.postcode)

        ' Set the value of the ICustomerMod.Phone element. 
        customerMod.Phone.SetValue(cust.telephone)

        ' Set the value of the ICustomerMod.Fax element. 
        customerMod.Fax.SetValue(cust.fax)


        ' Set the value of the ICustomerAdd.Email element. 
        customerMod.Email.SetValue(cust.emailAddress)

        ' Set the FullName value. 
        customerMod.SalesTaxCodeRef.FullName.SetValue(cust.salesTaxCode)

        If (cust.group = "Retail") Then
            '' Set terms????
        Else
            customerMod.TermsRef.FullName.SetValue("Net 30")
        End If

        customerMod.Notes.SetValue(cust.notes)
        customerMod.IncludeRetElementList.Add("ListID")
        customerMod.IncludeRetElementList.Add("EditSequence")
        customerMod.IncludeRetElementList.Add("Name")
    End Sub
End Module

