Option Strict On
Option Explicit On 

Imports Interop.QBFC5
Module BuildInvoiceAddRqModule

    Public Sub BuildInvoiceAddRq(ByVal o As Order, ByVal requestMsgSet As IMsgSetRequest, ByVal country As String)

        If (requestMsgSet Is Nothing) Then
            Exit Sub
        End If

        'Add the request to the message set request object. 
        Dim invoiceAdd As IInvoiceAdd
        invoiceAdd = requestMsgSet.AppendInvoiceAddRq()
        invoiceAdd.CustomerRef.ListID.SetValue(o.customerListId)
        invoiceAdd.ClassRef.FullName.SetValue(o.className)

        ' Set the FullName value. 
        '''''''''''''''invoiceAdd.ARAccountRef.FullName.SetValue("Accounts Receivable")

        ' Set the FullName value. 
        '''''''''''''''''''''''''''invoiceAdd.TemplateRef.FullName.SetValue("ab")

        invoiceAdd.TxnDate.SetValue(CType(o.shipDate, Date))
        invoiceAdd.DueDate.SetValue(CType(o.shipDate, Date).AddDays(30))
        invoiceAdd.RefNumber.SetValue(o.id)
        invoiceAdd.BillAddress.Addr1.SetValue(o.billingCompany)
        invoiceAdd.BillAddress.Addr2.SetValue(o.billingName)
        invoiceAdd.BillAddress.Addr3.SetValue(o.billingStreetAddress)
        invoiceAdd.BillAddress.City.SetValue(o.billingCity)
        invoiceAdd.BillAddress.State.SetValue(o.billingState)
        invoiceAdd.BillAddress.PostalCode.SetValue(o.billingPostcode)
        invoiceAdd.BillAddress.Country.SetValue(o.billingCountry)
        invoiceAdd.ShipAddress.Addr1.SetValue(o.shippingCompany)
        invoiceAdd.ShipAddress.Addr2.SetValue(o.shippingName)
        invoiceAdd.ShipAddress.Addr3.SetValue(o.shippingStreetAddress)
        invoiceAdd.ShipAddress.City.SetValue(o.shippingCity)
        invoiceAdd.ShipAddress.State.SetValue(o.shippingState)
        invoiceAdd.ShipAddress.PostalCode.SetValue(o.shippingPostcode)
        invoiceAdd.ShipAddress.Country.SetValue(o.shippingCountry)
        invoiceAdd.PONumber.SetValue(o.poNumber)
        invoiceAdd.ClassRef.FullName.SetValue(o.className)

        ' Set the value of the IInvoiceAdd.ShipDate element. 
        invoiceAdd.ShipDate.SetValue(CType(o.shipDate, Date))
        invoiceAdd.Memo.SetValue(o.notes)

        If o.shipMethod.ToUpper.IndexOf("FEDERAL EXPRESS") >= 0 Then
            invoiceAdd.ShipMethodRef.FullName.SetValue("Federal Express")
        ElseIf o.shipMethod.ToUpper.IndexOf("UNITED STATES POSTAL SERVICE") >= 0 Then
            invoiceAdd.ShipMethodRef.FullName.SetValue("USPS")
        ElseIf o.shipMethod.ToUpper.IndexOf("UNITED PARCEL SERVICE") >= 0 Then
            invoiceAdd.ShipMethodRef.FullName.SetValue("UPS")
        End If

        invoiceAdd.TemplateRef.FullName.SetValue("CS-RC Invoice")


        ' Set the FullName value. 
        ''''''''''''''''''''invoiceAdd.ShipMethodRef.FullName.SetValue(o.shipMethod)

        'If (country = "US") Then
        '    ' Set the FullName value. 
        '    invoiceAdd.ItemSalesTaxRef.FullName.SetValue("ab")

        '    ' Set the ListID value. 
        '    invoiceAdd.ItemSalesTaxRef.ListID.SetValue("ab")

        'End If
        ' Set the value of the IInvoiceAdd.Memo element. 
        '''''''''''''''''''''''invoiceAdd.Memo.SetValue("val")

        'If (country = "US") Then
        '    ' Set the FullName value. 
        '    invoiceAdd.CustomerSalesTaxCodeRef.FullName.SetValue("ab")

        '    ' Set the ListID value. 
        '    invoiceAdd.CustomerSalesTaxCodeRef.ListID.SetValue("ab")

        'End If
        'Add multiple elements to the list. In this case we will add 5 elements. 
        Dim orInvoiceLineAdd1 As IORInvoiceLineAdd
        Dim j As Integer
        If Not o.lineItems Is Nothing Then
            For j = 0 To o.lineItems.Length - 1
                Dim item As OrderLineItem = o.lineItems(j)
                orInvoiceLineAdd1 = invoiceAdd.ORInvoiceLineAddList.Append()
                orInvoiceLineAdd1.InvoiceLineAdd.ItemRef.FullName.SetValue(item.itemRefName)
                orInvoiceLineAdd1.InvoiceLineAdd.Desc.SetValue(item.description)
                orInvoiceLineAdd1.InvoiceLineAdd.Quantity.SetValue(item.quantity)
                orInvoiceLineAdd1.InvoiceLineAdd.ORRatePriceLevel.Rate.SetValue(item.amount)
                If item.isTaxable Then
                    orInvoiceLineAdd1.InvoiceLineAdd.SalesTaxCodeRef.FullName.SetValue("Tax")
                Else
                    orInvoiceLineAdd1.InvoiceLineAdd.SalesTaxCodeRef.FullName.SetValue("Non")
                End If
            Next
        End If

        '''''''''''''''''''''''''''''''invoiceAdd.IncludeRetElementList.Add("ListID")
        invoiceAdd.IncludeRetElementList.Add("EditSequence")
        invoiceAdd.IncludeRetElementList.Add("ListID")
        invoiceAdd.IncludeRetElementList.Add("RefNumber")

    End Sub
End Module

