Public Class Customer
    Public id As Integer
    Public companyName As String
    Public lastName As String
    Public firstName As String
    Public group As String ' Retail or Wholesale
    Public emailAddress As String
    Public telephone As String
    Public fax As String
    Public notes As String
    Public streetAddress As String
    Public streetAddress2 As String = ""
    Public streetAddress3 As String = ""
    Public streetAddress4 As String = ""
    Public city As String
    Public postcode As String
    Public state As String
    Public country As String
    Public editSequence As String
    Public listId As String
    Public creditAmount As Double

    Public salesTaxCode As String
    Public itemSalesTaxCode As String
    Public existsInQB As Boolean = False

    Public Sub setCompanyName(ByVal val As String)
        If Len(val) > 41 Then
            val = val.Substring(0, 41)
        End If
        companyName = removeSpecialChars(val)
    End Sub

    Public Sub setLastName(ByVal val)
        If Len(val) > 25 Then
            val = val.Substring(0, 25)
        End If
        lastName = removeSpecialChars(val)
    End Sub

    Public Sub setFirstName(ByVal val)
        If Len(val) > 25 Then
            val = val.Substring(0, 25)
        End If
        firstName = removeSpecialChars(val)
    End Sub

    Public Sub setGroup(ByVal val)
        group = val
    End Sub

    Public Sub setEmailAddress(ByVal val)
        If Len(val) > 99 Then
            val = val.Substring(0, 99)
        End If
        emailAddress = removeSpecialChars(val)
    End Sub

    Public Sub setFax(ByVal val As String)
        If Len(val) > 21 Then
            val = val.Substring(0, 21)
        End If
        fax = removeSpecialChars(val)
    End Sub

    Public Sub setTelephone(ByVal val As String)
        If Len(val) > 21 Then
            val = val.Substring(0, 21)
        End If
        telephone = removeSpecialChars(val)
    End Sub

    Public Sub setNotes(ByVal val As String)
        If Len(val) > 4095 Then
            val = val.Substring(0, 4095)
        End If
        notes = removeSpecialChars(val)
    End Sub

    Public Sub setStreetAddress(ByVal val As String)
        If Len(val) > 41 Then
            val = val.Substring(0, 41)
        End If
        streetAddress = removeSpecialChars(val)
    End Sub

    Public Sub setCity(ByVal val As String)
        If Len(val) > 31 Then
            val = val.Substring(0, 31)
        End If
        city = removeSpecialChars(val)
    End Sub

    Public Sub setPostCode(ByVal val As String)
        If Len(val) > 13 Then
            val = val.Substring(0, 13)
        End If
        postcode = removeSpecialChars(val)
    End Sub

    Public Sub setState(ByVal val As String)
        If Len(val) > 21 Then
            val = val.Substring(0, 21)
        End If
        state = removeSpecialChars(val)
    End Sub

    Public Sub setCountry(ByVal val As String)
        If Len(val) > 31 Then
            val = val.Substring(0, 31)
        End If
        country = removeSpecialChars(val)
    End Sub


    Public Function getQBName() As String
        Dim lLen As Long
        Dim sAns As String
        Dim lCtr As Long
        Dim sChar As String

        If Len(Trim(companyName)) > 0 Then
            getQBName = Trim(companyName)
        Else
            getQBName = Trim(lastName)
        End If
        lLen = Len(getQBName)
        For lCtr = 1 To lLen
            sChar = Mid(getQBName, lCtr, 1)
            If IsAlphaNumeric(sChar) Then
                sAns = sAns & sChar
            End If
        Next
        If Len(sAns) > 10 Then
            getQBName = sAns.Substring(0, 10) & " (" & id & ")"
        Else
            getQBName = sAns & " (" & id & ")"
        End If

    End Function

    Public Sub setSalesTaxCode(ByVal code)
        salesTaxCode = code
    End Sub

    Private Function IsAlphaNumeric(ByVal sChr As String) As Boolean
        IsAlphaNumeric = sChr Like "[0-9A-Za-z]"
    End Function

    Private Function removeSpecialChars(ByVal s As String) As String
        If s Is Nothing Then
            Return s
        End If

        Return s.Replace("/", "-").Replace(":", "-").Replace("'", "`")
    End Function

End Class
